#!/usr/bin/php -q
<?php
/*
  Written By Bradley Kite <bradley[-a-t-]kitefamily.co.uk>
 +-------------------------------------------------------------------------+
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | cacti: a php-based graphing solution                                    |
 +-------------------------------------------------------------------------+
*/

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0])) {
        die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;

include(dirname(__FILE__)."/include/config.php");

function usage()
{
?>
    Usage: add_perms.php [ --group-name [Group Name] | --user-id [ID] ] --item-type --item-id
        Where item-type is one of: graph, tree, host or graph_template
<?php
}

if ($_SERVER["argc"] == 1)
{
    usage();
    return(1);
}
else
{
    $groupName = '';
    $userId    = 0;

    $itemTypes = array('graph' => 1, 'tree' => 2, 'host' => 3, 'graph_template' => 4);

    $itemType  = 0;
    $itemId = 0;

    for ($i = 1; $i < $_SERVER["argc"]; $i++)
    {
        switch($_SERVER["argv"][$i])
        {
            case "--user-id":
                $i++;
                $userId = $_SERVER["argv"][$i];
                break;
            case "--group-name":
                $i++;
                $groupName = $_SERVER["argv"][$i];
                break;
            case "--item-type":
                $i++;
                $itemType = $itemTypes[$_SERVER["argv"][$i]];
                break;
            case "--item-id":
                $i++;
                $itemId = $_SERVER["argv"][$i];
                break;
            default:
                usage();
                return 1;
        }
    }

    if ($itemType == 0 || $itemId == 0)
    {
        usage();
        return 1;
    }

    $userIds = array();

    if (isset($groupName) && $groupName != '')
    {
        $users = db_fetch_assoc("select id from user_auth where oss_group = \"$groupName\"");
        foreach ($users as $u)
          array_push($userIds, $u["id"]);
    }
    elseif(isset($userId) && $userId > 0)
    {
        array_push($userIds, $userId);
    }
    foreach ($userIds as $id)
    {
        db_execute("replace into user_auth_perms (user_id, item_id, type) values ($id, $itemId, $itemType)");
    }
}

?>
